/* pathbar.c generated by valac 0.42.5, the Vala compiler
 * generated from pathbar.vala, do not modify */

/*
  This file is part of Dconf Editor

  Dconf Editor is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  Dconf Editor is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with Dconf Editor.  If not, see <https://www.gnu.org/licenses/>.
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>


#define TYPE_PATH_BAR (path_bar_get_type ())
#define PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR, PathBar))
#define PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR, PathBarClass))
#define IS_PATH_BAR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR))
#define IS_PATH_BAR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR))
#define PATH_BAR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR, PathBarClass))

typedef struct _PathBar PathBar;
typedef struct _PathBarClass PathBarClass;
typedef struct _PathBarPrivate PathBarPrivate;

#define TYPE_PATH_BAR_ITEM (path_bar_item_get_type ())
#define PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PATH_BAR_ITEM, PathBarItem))
#define PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PATH_BAR_ITEM, PathBarItemClass))
#define IS_PATH_BAR_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PATH_BAR_ITEM))
#define IS_PATH_BAR_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PATH_BAR_ITEM))
#define PATH_BAR_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PATH_BAR_ITEM, PathBarItemClass))

typedef struct _PathBarItem PathBarItem;
typedef struct _PathBarItemClass PathBarItemClass;
enum  {
	PATH_BAR_0_PROPERTY,
	PATH_BAR_COMPLETE_PATH_PROPERTY,
	PATH_BAR_NUM_PROPERTIES
};
static GParamSpec* path_bar_properties[PATH_BAR_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef enum  {
	VIEW_TYPE_OBJECT,
	VIEW_TYPE_FOLDER,
	VIEW_TYPE_SEARCH
} ViewType;


#define TYPE_VIEW_TYPE (view_type_get_type ())
typedef struct _Block23Data Block23Data;
typedef struct _Block24Data Block24Data;
typedef enum  {
	PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT,
	PATH_BAR_ITEM_CURSOR_TYPE_POINTER,
	PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT
} PathBarItemCursorType;


#define PATH_BAR_ITEM_TYPE_CURSOR_TYPE (path_bar_item_cursor_type_get_type ())
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _Block25Data Block25Data;
typedef struct _PathBarItemPrivate PathBarItemPrivate;
enum  {
	PATH_BAR_ITEM_0_PROPERTY,
	PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY,
	PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY,
	PATH_BAR_ITEM_TEXT_STRING_PROPERTY,
	PATH_BAR_ITEM_NUM_PROPERTIES
};
static GParamSpec* path_bar_item_properties[PATH_BAR_ITEM_NUM_PROPERTIES];

struct _PathBar {
	GtkBox parent_instance;
	PathBarPrivate * priv;
};

struct _PathBarClass {
	GtkBoxClass parent_class;
};

struct _PathBarPrivate {
	PathBarItem* root_button;
	gchar* _complete_path;
};

struct _Block23Data {
	int _ref_count_;
	PathBar* self;
	gchar** split;
	gint split_length1;
	gint _split_size_;
	gboolean destroy_all;
	gboolean maintain_all;
	ViewType type;
};

struct _Block24Data {
	int _ref_count_;
	PathBar* self;
	gchar* action_target;
	gchar* non_ghost_path;
	gboolean is_search;
};

struct _Block25Data {
	int _ref_count_;
	PathBar* self;
	gboolean is_search;
};

struct _PathBarItem {
	GtkButton parent_instance;
	PathBarItemPrivate * priv;
};

struct _PathBarItemClass {
	GtkButtonClass parent_class;
};

struct _PathBarItemPrivate {
	gchar* _alternative_action;
	gchar* _default_action;
	gchar* _text_string;
	GtkLabel* text_label;
	PathBarItemCursorType cursor_type;
	gboolean hover;
};


static gint PathBar_private_offset;
static gpointer path_bar_parent_class = NULL;
static gint PathBarItem_private_offset;
static gpointer path_bar_item_parent_class = NULL;

GType path_bar_get_type (void) G_GNUC_CONST;
GType path_bar_item_get_type (void) G_GNUC_CONST;
GType view_type_get_type (void) G_GNUC_CONST;
void path_bar_set_path (PathBar* self,
                        ViewType type,
                        const gchar* path);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void path_bar_update_cursors_for_search (PathBar* self,
                                         const gchar* current_path,
                                         gboolean is_search);
static void path_bar_activate_item (PathBar* self,
                             PathBarItem* item,
                             gboolean state);
static void path_bar_set_complete_path (PathBar* self,
                                 const gchar* value);
static void __lambda22_ (Block23Data* _data23_,
                  GtkWidget* child);
const gchar* path_bar_get_complete_path (PathBar* self);
const gchar* path_bar_item_get_text_string (PathBarItem* self);
static gchar** _vala_array_dup4 (gchar** self,
                          int length);
static void ___lambda22__gtk_callback (GtkWidget* widget,
                                gpointer self);
static void path_bar_add_path_bar_item (PathBar* self,
                                 const gchar* label,
                                 const gchar* complete_path,
                                 gboolean is_folder,
                                 gboolean block);
static void path_bar_add_slash_label (PathBar* self);
gchar* path_bar_get_selected_child (PathBar* self,
                                    const gchar* current_path);
void path_bar_update_ghosts (PathBar* self,
                             const gchar* non_ghost_path,
                             gboolean is_search);
static Block24Data* block24_data_ref (Block24Data* _data24_);
static void block24_data_unref (void * _userdata_);
static void __lambda23_ (Block24Data* _data24_,
                  GtkWidget* child);
GType path_bar_item_cursor_type_get_type (void) G_GNUC_CONST;
void path_bar_item_set_cursor_type (PathBarItem* self,
                                    PathBarItemCursorType cursor_type);
const gchar* path_bar_item_get_default_action (PathBarItem* self);
const gchar* path_bar_item_get_alternative_action (PathBarItem* self);
static void ___lambda23__gtk_callback (GtkWidget* widget,
                                gpointer self);
static Block25Data* block25_data_ref (Block25Data* _data25_);
static void block25_data_unref (void * _userdata_);
static void __lambda21_ (Block25Data* _data25_,
                  GtkWidget* child);
static void ___lambda21__gtk_callback (GtkWidget* widget,
                                gpointer self);
PathBarItem* path_bar_item_new (const gchar* label,
                                const gchar* _default_action,
                                const gchar* _alternative_action);
PathBarItem* path_bar_item_construct (GType object_type,
                                      const gchar* label,
                                      const gchar* _default_action,
                                      const gchar* _alternative_action);
PathBar* path_bar_new (void);
PathBar* path_bar_construct (GType object_type);
static GObject * path_bar_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties);
static void path_bar_finalize (GObject * obj);
static void _vala_path_bar_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec);
static void _vala_path_bar_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec);
static void path_bar_item_set_new_cursor_type (PathBarItem* self,
                                        PathBarItemCursorType new_cursor_type);
static void path_bar_item_update_cursor (PathBarItem* self);
static void _path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                      gpointer self);
static void path_bar_item_set_alternative_action (PathBarItem* self,
                                           const gchar* value);
static void path_bar_item_set_default_action (PathBarItem* self,
                                       const gchar* value);
static void path_bar_item_set_text_string (PathBarItem* self,
                                    const gchar* value);
static GObject * path_bar_item_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static gboolean _path_bar_item___lambda19_ (PathBarItem* self);
static gboolean __path_bar_item___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static gboolean _path_bar_item___lambda20_ (PathBarItem* self);
static gboolean __path_bar_item___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                                    GdkEventCrossing* event,
                                                                    gpointer self);
static void path_bar_item_finalize (GObject * obj);
static void _vala_path_bar_item_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec);
static void _vala_path_bar_item_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
path_bar_get_instance_private (PathBar* self)
{
	return G_STRUCT_MEMBER_P (self, PathBar_private_offset);
}


static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 36 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 36 "../editor/pathbar.vala"
	return _data23_;
#line 281 "pathbar.c"
}


static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 36 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 292 "pathbar.c"
		PathBar* self;
#line 36 "../editor/pathbar.vala"
		self = _data23_->self;
#line 36 "../editor/pathbar.vala"
		_data23_->split = (_vala_array_free (_data23_->split, _data23_->split_length1, (GDestroyNotify) g_free), NULL);
#line 36 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 36 "../editor/pathbar.vala"
		g_slice_free (Block23Data, _data23_);
#line 302 "pathbar.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 63 "../editor/pathbar.vala"
	return self ? g_object_ref (self) : NULL;
#line 312 "pathbar.c"
}


static gchar**
_vala_array_dup4 (gchar** self,
                  int length)
{
	gchar** result;
	int i;
#line 75 "../editor/pathbar.vala"
	result = g_new0 (gchar*, length + 1);
#line 75 "../editor/pathbar.vala"
	for (i = 0; i < length; i++) {
#line 326 "pathbar.c"
		gchar* _tmp0_;
#line 75 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (self[i]);
#line 75 "../editor/pathbar.vala"
		result[i] = _tmp0_;
#line 332 "pathbar.c"
	}
#line 75 "../editor/pathbar.vala"
	return result;
#line 336 "pathbar.c"
}


static void
__lambda22_ (Block23Data* _data23_,
             GtkWidget* child)
{
	PathBar* self;
	PathBarItem* item = NULL;
	PathBarItem* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp13_ = FALSE;
	PathBarItem* _tmp14_;
	PathBarItem* _tmp15_;
#line 53 "../editor/pathbar.vala"
	self = _data23_->self;
#line 53 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 54 "../editor/pathbar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, gtk_label_get_type ())) {
#line 357 "pathbar.c"
		gboolean _tmp0_;
#line 56 "../editor/pathbar.vala"
		_tmp0_ = _data23_->destroy_all;
#line 56 "../editor/pathbar.vala"
		if (_tmp0_) {
#line 57 "../editor/pathbar.vala"
			gtk_widget_destroy (child);
#line 365 "pathbar.c"
		} else {
			const gchar* _tmp1_;
			gchar* _tmp2_;
			gchar* _tmp3_;
#line 59 "../editor/pathbar.vala"
			_tmp1_ = self->priv->_complete_path;
#line 59 "../editor/pathbar.vala"
			_tmp2_ = g_strconcat (_tmp1_, "/", NULL);
#line 59 "../editor/pathbar.vala"
			_tmp3_ = _tmp2_;
#line 59 "../editor/pathbar.vala"
			path_bar_set_complete_path (self, _tmp3_);
#line 59 "../editor/pathbar.vala"
			_g_free0 (_tmp3_);
#line 380 "pathbar.c"
		}
#line 60 "../editor/pathbar.vala"
		return;
#line 384 "pathbar.c"
	}
#line 63 "../editor/pathbar.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 63 "../editor/pathbar.vala"
	item = _tmp4_;
#line 65 "../editor/pathbar.vala"
	_tmp5_ = _data23_->maintain_all;
#line 65 "../editor/pathbar.vala"
	if (_tmp5_) {
#line 394 "pathbar.c"
		const gchar* _tmp6_;
		PathBarItem* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		PathBarItem* _tmp12_;
#line 67 "../editor/pathbar.vala"
		_tmp6_ = self->priv->_complete_path;
#line 67 "../editor/pathbar.vala"
		_tmp7_ = item;
#line 67 "../editor/pathbar.vala"
		_tmp8_ = path_bar_item_get_text_string (_tmp7_);
#line 67 "../editor/pathbar.vala"
		_tmp9_ = _tmp8_;
#line 67 "../editor/pathbar.vala"
		_tmp10_ = g_strconcat (_tmp6_, _tmp9_, NULL);
#line 67 "../editor/pathbar.vala"
		_tmp11_ = _tmp10_;
#line 67 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, _tmp11_);
#line 67 "../editor/pathbar.vala"
		_g_free0 (_tmp11_);
#line 68 "../editor/pathbar.vala"
		_tmp12_ = item;
#line 68 "../editor/pathbar.vala"
		path_bar_activate_item (self, _tmp12_, FALSE);
#line 69 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 69 "../editor/pathbar.vala"
		return;
#line 426 "pathbar.c"
	}
#line 72 "../editor/pathbar.vala"
	_tmp14_ = item;
#line 72 "../editor/pathbar.vala"
	_tmp15_ = self->priv->root_button;
#line 72 "../editor/pathbar.vala"
	if (_tmp14_ == _tmp15_) {
#line 72 "../editor/pathbar.vala"
		_tmp13_ = TRUE;
#line 436 "pathbar.c"
	} else {
		gboolean _tmp16_ = FALSE;
		gboolean _tmp17_;
#line 72 "../editor/pathbar.vala"
		_tmp17_ = _data23_->destroy_all;
#line 72 "../editor/pathbar.vala"
		if (!_tmp17_) {
#line 444 "pathbar.c"
			PathBarItem* _tmp18_;
			const gchar* _tmp19_;
			const gchar* _tmp20_;
			gchar** _tmp21_;
			gint _tmp21__length1;
			const gchar* _tmp22_;
#line 72 "../editor/pathbar.vala"
			_tmp18_ = item;
#line 72 "../editor/pathbar.vala"
			_tmp19_ = path_bar_item_get_text_string (_tmp18_);
#line 72 "../editor/pathbar.vala"
			_tmp20_ = _tmp19_;
#line 72 "../editor/pathbar.vala"
			_tmp21_ = _data23_->split;
#line 72 "../editor/pathbar.vala"
			_tmp21__length1 = _data23_->split_length1;
#line 72 "../editor/pathbar.vala"
			_tmp22_ = _tmp21_[0];
#line 72 "../editor/pathbar.vala"
			_tmp16_ = g_strcmp0 (_tmp20_, _tmp22_) == 0;
#line 465 "pathbar.c"
		} else {
#line 72 "../editor/pathbar.vala"
			_tmp16_ = FALSE;
#line 469 "pathbar.c"
		}
#line 72 "../editor/pathbar.vala"
		_tmp13_ = _tmp16_;
#line 473 "pathbar.c"
	}
#line 72 "../editor/pathbar.vala"
	if (_tmp13_) {
#line 477 "pathbar.c"
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gint _tmp24__length1;
		const gchar* _tmp25_;
		gchar* _tmp26_;
		gchar* _tmp27_;
		gchar** _tmp28_;
		gint _tmp28__length1;
		gchar** _tmp29_;
		gint _tmp29__length1;
		gchar** _tmp30_;
		gint _tmp30__length1;
		gboolean _tmp31_ = FALSE;
		gchar** _tmp32_;
		gint _tmp32__length1;
#line 74 "../editor/pathbar.vala"
		_tmp23_ = self->priv->_complete_path;
#line 74 "../editor/pathbar.vala"
		_tmp24_ = _data23_->split;
#line 74 "../editor/pathbar.vala"
		_tmp24__length1 = _data23_->split_length1;
#line 74 "../editor/pathbar.vala"
		_tmp25_ = _tmp24_[0];
#line 74 "../editor/pathbar.vala"
		_tmp26_ = g_strconcat (_tmp23_, _tmp25_, NULL);
#line 74 "../editor/pathbar.vala"
		_tmp27_ = _tmp26_;
#line 74 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, _tmp27_);
#line 74 "../editor/pathbar.vala"
		_g_free0 (_tmp27_);
#line 75 "../editor/pathbar.vala"
		_tmp28_ = _data23_->split;
#line 75 "../editor/pathbar.vala"
		_tmp28__length1 = _data23_->split_length1;
#line 75 "../editor/pathbar.vala"
		_tmp29_ = _data23_->split;
#line 75 "../editor/pathbar.vala"
		_tmp29__length1 = _data23_->split_length1;
#line 75 "../editor/pathbar.vala"
		_tmp30_ = ((_tmp28_ + 1) != NULL) ? _vala_array_dup4 (_tmp28_ + 1, _tmp29__length1 - 1) : ((gpointer) (_tmp28_ + 1));
#line 75 "../editor/pathbar.vala"
		_tmp30__length1 = _tmp29__length1 - 1;
#line 75 "../editor/pathbar.vala"
		_data23_->split = (_vala_array_free (_data23_->split, _data23_->split_length1, (GDestroyNotify) g_free), NULL);
#line 75 "../editor/pathbar.vala"
		_data23_->split = _tmp30_;
#line 75 "../editor/pathbar.vala"
		_data23_->split_length1 = _tmp30__length1;
#line 75 "../editor/pathbar.vala"
		_data23_->_split_size_ = _data23_->split_length1;
#line 76 "../editor/pathbar.vala"
		_tmp32_ = _data23_->split;
#line 76 "../editor/pathbar.vala"
		_tmp32__length1 = _data23_->split_length1;
#line 76 "../editor/pathbar.vala"
		if (_tmp32__length1 == 0) {
#line 76 "../editor/pathbar.vala"
			_tmp31_ = TRUE;
#line 537 "pathbar.c"
		} else {
			gboolean _tmp33_ = FALSE;
			gchar** _tmp34_;
			gint _tmp34__length1;
#line 76 "../editor/pathbar.vala"
			_tmp34_ = _data23_->split;
#line 76 "../editor/pathbar.vala"
			_tmp34__length1 = _data23_->split_length1;
#line 76 "../editor/pathbar.vala"
			if (_tmp34__length1 == 1) {
#line 76 "../editor/pathbar.vala"
				_tmp33_ = _data23_->type == VIEW_TYPE_FOLDER;
#line 550 "pathbar.c"
			} else {
#line 76 "../editor/pathbar.vala"
				_tmp33_ = FALSE;
#line 554 "pathbar.c"
			}
#line 76 "../editor/pathbar.vala"
			_tmp31_ = _tmp33_;
#line 558 "pathbar.c"
		}
#line 76 "../editor/pathbar.vala"
		if (_tmp31_) {
#line 562 "pathbar.c"
			PathBarItem* _tmp35_;
#line 78 "../editor/pathbar.vala"
			_tmp35_ = item;
#line 78 "../editor/pathbar.vala"
			path_bar_activate_item (self, _tmp35_, TRUE);
#line 79 "../editor/pathbar.vala"
			_data23_->maintain_all = TRUE;
#line 570 "pathbar.c"
		} else {
			PathBarItem* _tmp36_;
#line 82 "../editor/pathbar.vala"
			_tmp36_ = item;
#line 82 "../editor/pathbar.vala"
			path_bar_activate_item (self, _tmp36_, FALSE);
#line 577 "pathbar.c"
		}
#line 83 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 83 "../editor/pathbar.vala"
		return;
#line 583 "pathbar.c"
	}
#line 86 "../editor/pathbar.vala"
	gtk_widget_destroy (child);
#line 87 "../editor/pathbar.vala"
	_data23_->destroy_all = TRUE;
#line 53 "../editor/pathbar.vala"
	_g_object_unref0 (item);
#line 591 "pathbar.c"
}


static void
___lambda22__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 53 "../editor/pathbar.vala"
	__lambda22_ (self, widget);
#line 601 "pathbar.c"
}


void
path_bar_set_path (PathBar* self,
                   ViewType type,
                   const gchar* path)
{
	Block23Data* _data23_;
	PathBarItem* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gchar* last = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
#line 36 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 36 "../editor/pathbar.vala"
	g_return_if_fail (path != NULL);
#line 36 "../editor/pathbar.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 36 "../editor/pathbar.vala"
	_data23_->_ref_count_ = 1;
#line 36 "../editor/pathbar.vala"
	_data23_->self = g_object_ref (self);
#line 36 "../editor/pathbar.vala"
	_data23_->type = type;
#line 38 "../editor/pathbar.vala"
	if (_data23_->type == VIEW_TYPE_SEARCH) {
#line 40 "../editor/pathbar.vala"
		path_bar_update_cursors_for_search (self, path, TRUE);
#line 41 "../editor/pathbar.vala"
		block23_data_unref (_data23_);
#line 41 "../editor/pathbar.vala"
		_data23_ = NULL;
#line 41 "../editor/pathbar.vala"
		return;
#line 645 "pathbar.c"
	}
#line 43 "../editor/pathbar.vala"
	path_bar_update_cursors_for_search (self, path, FALSE);
#line 45 "../editor/pathbar.vala"
	_tmp0_ = self->priv->root_button;
#line 45 "../editor/pathbar.vala"
	path_bar_activate_item (self, _tmp0_, g_strcmp0 (path, "/") == 0);
#line 47 "../editor/pathbar.vala"
	path_bar_set_complete_path (self, "");
#line 48 "../editor/pathbar.vala"
	_tmp2_ = _tmp1_ = g_strsplit (path, "/", 0);
#line 48 "../editor/pathbar.vala"
	_data23_->split = _tmp2_;
#line 48 "../editor/pathbar.vala"
	_data23_->split_length1 = _vala_array_length (_tmp1_);
#line 48 "../editor/pathbar.vala"
	_data23_->_split_size_ = _data23_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp3_ = _data23_->split;
#line 49 "../editor/pathbar.vala"
	_tmp3__length1 = _data23_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp4_ = _data23_->split;
#line 49 "../editor/pathbar.vala"
	_tmp4__length1 = _data23_->split_length1;
#line 49 "../editor/pathbar.vala"
	_tmp5_ = _tmp3_[_tmp4__length1 - 1];
#line 49 "../editor/pathbar.vala"
	_tmp6_ = g_strdup (_tmp5_);
#line 49 "../editor/pathbar.vala"
	last = _tmp6_;
#line 51 "../editor/pathbar.vala"
	_data23_->destroy_all = FALSE;
#line 52 "../editor/pathbar.vala"
	_data23_->maintain_all = FALSE;
#line 53 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda22__gtk_callback, _data23_);
#line 90 "../editor/pathbar.vala"
	_tmp7_ = _data23_->split;
#line 90 "../editor/pathbar.vala"
	_tmp7__length1 = _data23_->split_length1;
#line 90 "../editor/pathbar.vala"
	if (_tmp7__length1 > 0) {
#line 689 "pathbar.c"
		gchar** _tmp8_;
		gint _tmp8__length1;
#line 93 "../editor/pathbar.vala"
		_tmp8_ = _data23_->split;
#line 93 "../editor/pathbar.vala"
		_tmp8__length1 = _data23_->split_length1;
#line 93 "../editor/pathbar.vala"
		if (_tmp8__length1 > 1) {
#line 698 "pathbar.c"
			guint index = 0U;
			gchar** _tmp9_;
			gint _tmp9__length1;
			gchar** _tmp10_;
			gint _tmp10__length1;
#line 95 "../editor/pathbar.vala"
			index = (guint) 0;
#line 96 "../editor/pathbar.vala"
			_tmp9_ = _data23_->split;
#line 96 "../editor/pathbar.vala"
			_tmp9__length1 = _data23_->split_length1;
#line 96 "../editor/pathbar.vala"
			_tmp10_ = _data23_->split;
#line 96 "../editor/pathbar.vala"
			_tmp10__length1 = _data23_->split_length1;
#line 714 "pathbar.c"
			{
				gchar** item_collection = NULL;
				gint item_collection_length1 = 0;
				gint _item_collection_size_ = 0;
				gint item_it = 0;
#line 96 "../editor/pathbar.vala"
				item_collection = _tmp9_ + 0;
#line 96 "../editor/pathbar.vala"
				item_collection_length1 = (_tmp10__length1 - 1) - 0;
#line 96 "../editor/pathbar.vala"
				for (item_it = 0; item_it < ((_tmp10__length1 - 1) - 0); item_it = item_it + 1) {
#line 726 "pathbar.c"
					gchar* _tmp11_;
					gchar* item = NULL;
#line 96 "../editor/pathbar.vala"
					_tmp11_ = g_strdup (item_collection[item_it]);
#line 96 "../editor/pathbar.vala"
					item = _tmp11_;
#line 733 "pathbar.c"
					{
						const gchar* _tmp12_;
						const gchar* _tmp13_;
						gchar* _tmp14_;
						gchar* _tmp15_;
						gchar* _tmp16_;
						gchar* _tmp17_;
						gboolean _tmp18_ = FALSE;
						const gchar* _tmp21_;
						const gchar* _tmp22_;
						guint _tmp23_;
#line 98 "../editor/pathbar.vala"
						_tmp12_ = self->priv->_complete_path;
#line 98 "../editor/pathbar.vala"
						_tmp13_ = item;
#line 98 "../editor/pathbar.vala"
						_tmp14_ = g_strconcat (_tmp13_, "/", NULL);
#line 98 "../editor/pathbar.vala"
						_tmp15_ = _tmp14_;
#line 98 "../editor/pathbar.vala"
						_tmp16_ = g_strconcat (_tmp12_, _tmp15_, NULL);
#line 98 "../editor/pathbar.vala"
						_tmp17_ = _tmp16_;
#line 98 "../editor/pathbar.vala"
						path_bar_set_complete_path (self, _tmp17_);
#line 98 "../editor/pathbar.vala"
						_g_free0 (_tmp17_);
#line 98 "../editor/pathbar.vala"
						_g_free0 (_tmp15_);
#line 99 "../editor/pathbar.vala"
						if (_data23_->type == VIEW_TYPE_FOLDER) {
#line 765 "pathbar.c"
							guint _tmp19_;
							gchar** _tmp20_;
							gint _tmp20__length1;
#line 99 "../editor/pathbar.vala"
							_tmp19_ = index;
#line 99 "../editor/pathbar.vala"
							_tmp20_ = _data23_->split;
#line 99 "../editor/pathbar.vala"
							_tmp20__length1 = _data23_->split_length1;
#line 99 "../editor/pathbar.vala"
							_tmp18_ = _tmp19_ == ((guint) (_tmp20__length1 - 2));
#line 777 "pathbar.c"
						} else {
#line 99 "../editor/pathbar.vala"
							_tmp18_ = FALSE;
#line 781 "pathbar.c"
						}
#line 99 "../editor/pathbar.vala"
						_tmp21_ = item;
#line 99 "../editor/pathbar.vala"
						_tmp22_ = self->priv->_complete_path;
#line 99 "../editor/pathbar.vala"
						path_bar_add_path_bar_item (self, _tmp21_, _tmp22_, TRUE, _tmp18_);
#line 100 "../editor/pathbar.vala"
						path_bar_add_slash_label (self);
#line 101 "../editor/pathbar.vala"
						_tmp23_ = index;
#line 101 "../editor/pathbar.vala"
						index = _tmp23_ + 1;
#line 96 "../editor/pathbar.vala"
						_g_free0 (item);
#line 797 "pathbar.c"
					}
				}
			}
		}
#line 106 "../editor/pathbar.vala"
		if (_data23_->type == VIEW_TYPE_OBJECT) {
#line 804 "pathbar.c"
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 108 "../editor/pathbar.vala"
			_tmp24_ = self->priv->_complete_path;
#line 108 "../editor/pathbar.vala"
			_tmp25_ = last;
#line 108 "../editor/pathbar.vala"
			_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 108 "../editor/pathbar.vala"
			_tmp27_ = _tmp26_;
#line 108 "../editor/pathbar.vala"
			path_bar_set_complete_path (self, _tmp27_);
#line 108 "../editor/pathbar.vala"
			_g_free0 (_tmp27_);
#line 109 "../editor/pathbar.vala"
			_tmp28_ = last;
#line 109 "../editor/pathbar.vala"
			_tmp29_ = self->priv->_complete_path;
#line 109 "../editor/pathbar.vala"
			path_bar_add_path_bar_item (self, _tmp28_, _tmp29_, FALSE, TRUE);
#line 829 "pathbar.c"
		}
	}
#line 113 "../editor/pathbar.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 36 "../editor/pathbar.vala"
	_g_free0 (last);
#line 36 "../editor/pathbar.vala"
	block23_data_unref (_data23_);
#line 36 "../editor/pathbar.vala"
	_data23_ = NULL;
#line 840 "pathbar.c"
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 865 "pathbar.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 873 "pathbar.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 879 "pathbar.c"
	}
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 906 "pathbar.c"
		glong _tmp2_;
#line 1428 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1428 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 912 "pathbar.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 916 "pathbar.c"
		glong _tmp3_;
#line 1431 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1431 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 922 "pathbar.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 926 "pathbar.c"
		glong _tmp5_;
#line 1433 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1433 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 932 "pathbar.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 936 "pathbar.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 942 "pathbar.c"
		glong _tmp7_;
#line 1434 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1434 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 948 "pathbar.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 952 "pathbar.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp8_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 964 "pathbar.c"
}


gchar*
path_bar_get_selected_child (PathBar* self,
                             const gchar* current_path)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	const gchar* _tmp1_;
	gint index_of_last_slash = 0;
	const gchar* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
#line 116 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../editor/pathbar.vala"
	g_return_val_if_fail (current_path != NULL, NULL);
#line 118 "../editor/pathbar.vala"
	_tmp1_ = self->priv->_complete_path;
#line 118 "../editor/pathbar.vala"
	if (!g_str_has_prefix (_tmp1_, current_path)) {
#line 118 "../editor/pathbar.vala"
		_tmp0_ = TRUE;
#line 991 "pathbar.c"
	} else {
		const gchar* _tmp2_;
#line 118 "../editor/pathbar.vala"
		_tmp2_ = self->priv->_complete_path;
#line 118 "../editor/pathbar.vala"
		_tmp0_ = g_strcmp0 (_tmp2_, current_path) == 0;
#line 998 "pathbar.c"
	}
#line 118 "../editor/pathbar.vala"
	if (_tmp0_) {
#line 1002 "pathbar.c"
		gchar* _tmp3_;
#line 119 "../editor/pathbar.vala"
		_tmp3_ = g_strdup ("");
#line 119 "../editor/pathbar.vala"
		result = _tmp3_;
#line 119 "../editor/pathbar.vala"
		return result;
#line 1010 "pathbar.c"
	}
#line 120 "../editor/pathbar.vala"
	_tmp4_ = self->priv->_complete_path;
#line 120 "../editor/pathbar.vala"
	_tmp5_ = strlen (current_path);
#line 120 "../editor/pathbar.vala"
	_tmp6_ = _tmp5_;
#line 120 "../editor/pathbar.vala"
	index_of_last_slash = string_index_of (_tmp4_, "/", _tmp6_);
#line 121 "../editor/pathbar.vala"
	_tmp8_ = index_of_last_slash;
#line 121 "../editor/pathbar.vala"
	if (_tmp8_ == -1) {
#line 1024 "pathbar.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
#line 121 "../editor/pathbar.vala"
		_tmp9_ = self->priv->_complete_path;
#line 121 "../editor/pathbar.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 121 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 121 "../editor/pathbar.vala"
		_tmp7_ = _tmp10_;
#line 1035 "pathbar.c"
	} else {
		const gchar* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
#line 121 "../editor/pathbar.vala"
		_tmp11_ = self->priv->_complete_path;
#line 121 "../editor/pathbar.vala"
		_tmp12_ = index_of_last_slash;
#line 121 "../editor/pathbar.vala"
		_tmp13_ = string_slice (_tmp11_, (glong) 0, (glong) (_tmp12_ + 1));
#line 121 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 121 "../editor/pathbar.vala"
		_tmp7_ = _tmp13_;
#line 1050 "pathbar.c"
	}
#line 121 "../editor/pathbar.vala"
	result = _tmp7_;
#line 121 "../editor/pathbar.vala"
	return result;
#line 1056 "pathbar.c"
}


static Block24Data*
block24_data_ref (Block24Data* _data24_)
{
#line 124 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data24_->_ref_count_);
#line 124 "../editor/pathbar.vala"
	return _data24_;
#line 1067 "pathbar.c"
}


static void
block24_data_unref (void * _userdata_)
{
	Block24Data* _data24_;
	_data24_ = (Block24Data*) _userdata_;
#line 124 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data24_->_ref_count_)) {
#line 1078 "pathbar.c"
		PathBar* self;
#line 124 "../editor/pathbar.vala"
		self = _data24_->self;
#line 124 "../editor/pathbar.vala"
		_g_free0 (_data24_->action_target);
#line 124 "../editor/pathbar.vala"
		_g_free0 (_data24_->non_ghost_path);
#line 124 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 124 "../editor/pathbar.vala"
		g_slice_free (Block24Data, _data24_);
#line 1090 "pathbar.c"
	}
}


static gpointer
_g_variant_ref0 (gpointer self)
{
#line 132 "../editor/pathbar.vala"
	return self ? g_variant_ref (self) : NULL;
#line 1100 "pathbar.c"
}


static void
__lambda23_ (Block24Data* _data24_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
#line 127 "../editor/pathbar.vala"
	self = _data24_->self;
#line 127 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 128 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context (child);
#line 128 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 128 "../editor/pathbar.vala"
	context = _tmp1_;
#line 129 "../editor/pathbar.vala"
	if (G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
#line 1124 "pathbar.c"
		PathBarItem* item = NULL;
		PathBarItem* _tmp2_;
		GVariant* variant = NULL;
		PathBarItem* _tmp3_;
		GVariant* _tmp4_;
		GVariant* _tmp5_;
		GVariant* _tmp6_;
		GVariant* _tmp7_;
		const gchar* _tmp8_;
		GtkStyleContext* _tmp15_;
#line 131 "../editor/pathbar.vala"
		_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 131 "../editor/pathbar.vala"
		item = _tmp2_;
#line 132 "../editor/pathbar.vala"
		_tmp3_ = item;
#line 132 "../editor/pathbar.vala"
		_tmp4_ = gtk_actionable_get_action_target_value ((GtkActionable*) _tmp3_);
#line 132 "../editor/pathbar.vala"
		_tmp5_ = _g_variant_ref0 (_tmp4_);
#line 132 "../editor/pathbar.vala"
		variant = _tmp5_;
#line 133 "../editor/pathbar.vala"
		_tmp6_ = variant;
#line 133 "../editor/pathbar.vala"
		if (_tmp6_ == NULL) {
#line 134 "../editor/pathbar.vala"
			g_assert_not_reached ();
#line 1153 "pathbar.c"
		}
#line 135 "../editor/pathbar.vala"
		_tmp7_ = variant;
#line 135 "../editor/pathbar.vala"
		_tmp8_ = g_variant_get_type_string ((GVariant*) _tmp7_);
#line 135 "../editor/pathbar.vala"
		if (g_strcmp0 (_tmp8_, "s") == 0) {
#line 1161 "pathbar.c"
			GVariant* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 136 "../editor/pathbar.vala"
			_tmp9_ = variant;
#line 136 "../editor/pathbar.vala"
			_tmp10_ = g_variant_get_string ((GVariant*) _tmp9_, NULL);
#line 136 "../editor/pathbar.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 136 "../editor/pathbar.vala"
			_g_free0 (_data24_->action_target);
#line 136 "../editor/pathbar.vala"
			_data24_->action_target = _tmp11_;
#line 1175 "pathbar.c"
		} else {
			gchar* unused = NULL;
			GVariant* _tmp12_;
			gchar* _tmp13_ = NULL;
			gchar* _tmp14_ = NULL;
#line 140 "../editor/pathbar.vala"
			_tmp12_ = variant;
#line 140 "../editor/pathbar.vala"
			g_variant_get ((GVariant*) _tmp12_, "(ss)", &_tmp13_, &_tmp14_, NULL);
#line 140 "../editor/pathbar.vala"
			_g_free0 (_data24_->action_target);
#line 140 "../editor/pathbar.vala"
			_data24_->action_target = _tmp13_;
#line 140 "../editor/pathbar.vala"
			_g_free0 (unused);
#line 140 "../editor/pathbar.vala"
			unused = _tmp14_;
#line 135 "../editor/pathbar.vala"
			_g_free0 (unused);
#line 1195 "pathbar.c"
		}
#line 143 "../editor/pathbar.vala"
		_tmp15_ = context;
#line 143 "../editor/pathbar.vala"
		if (gtk_style_context_has_class (_tmp15_, "active")) {
#line 1201 "pathbar.c"
			GtkStyleContext* _tmp23_;
#line 145 "../editor/pathbar.vala"
			if (_data24_->is_search) {
#line 1205 "pathbar.c"
				PathBarItem* _tmp16_;
				PathBarItem* _tmp17_;
				PathBarItem* _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
#line 147 "../editor/pathbar.vala"
				_tmp16_ = item;
#line 147 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp16_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 148 "../editor/pathbar.vala"
				_tmp17_ = item;
#line 148 "../editor/pathbar.vala"
				_tmp18_ = item;
#line 148 "../editor/pathbar.vala"
				_tmp19_ = path_bar_item_get_default_action (_tmp18_);
#line 148 "../editor/pathbar.vala"
				_tmp20_ = _tmp19_;
#line 148 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp17_, _tmp20_);
#line 1225 "pathbar.c"
			} else {
				PathBarItem* _tmp21_;
				PathBarItem* _tmp22_;
#line 152 "../editor/pathbar.vala"
				_tmp21_ = item;
#line 152 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp21_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 153 "../editor/pathbar.vala"
				_tmp22_ = item;
#line 153 "../editor/pathbar.vala"
				gtk_actionable_set_action_name ((GtkActionable*) _tmp22_, "ui.empty");
#line 1237 "pathbar.c"
			}
#line 155 "../editor/pathbar.vala"
			_tmp23_ = context;
#line 155 "../editor/pathbar.vala"
			gtk_style_context_remove_class (_tmp23_, "inexistent");
#line 1243 "pathbar.c"
		} else {
#line 157 "../editor/pathbar.vala"
			if (g_str_has_prefix (_data24_->non_ghost_path, _data24_->action_target)) {
#line 1247 "pathbar.c"
				PathBarItem* _tmp24_;
				PathBarItem* _tmp25_;
				PathBarItem* _tmp26_;
				const gchar* _tmp27_;
				const gchar* _tmp28_;
				GtkStyleContext* _tmp29_;
#line 159 "../editor/pathbar.vala"
				_tmp24_ = item;
#line 159 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp24_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 160 "../editor/pathbar.vala"
				_tmp25_ = item;
#line 160 "../editor/pathbar.vala"
				_tmp26_ = item;
#line 160 "../editor/pathbar.vala"
				_tmp27_ = path_bar_item_get_default_action (_tmp26_);
#line 160 "../editor/pathbar.vala"
				_tmp28_ = _tmp27_;
#line 160 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp25_, _tmp28_);
#line 161 "../editor/pathbar.vala"
				_tmp29_ = context;
#line 161 "../editor/pathbar.vala"
				gtk_style_context_remove_class (_tmp29_, "inexistent");
#line 1272 "pathbar.c"
			} else {
				PathBarItem* _tmp30_;
				PathBarItem* _tmp31_;
				PathBarItem* _tmp32_;
				const gchar* _tmp33_;
				const gchar* _tmp34_;
				GtkStyleContext* _tmp35_;
#line 165 "../editor/pathbar.vala"
				_tmp30_ = item;
#line 165 "../editor/pathbar.vala"
				path_bar_item_set_cursor_type (_tmp30_, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
#line 166 "../editor/pathbar.vala"
				_tmp31_ = item;
#line 166 "../editor/pathbar.vala"
				_tmp32_ = item;
#line 166 "../editor/pathbar.vala"
				_tmp33_ = path_bar_item_get_alternative_action (_tmp32_);
#line 166 "../editor/pathbar.vala"
				_tmp34_ = _tmp33_;
#line 166 "../editor/pathbar.vala"
				gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp31_, _tmp34_);
#line 167 "../editor/pathbar.vala"
				_tmp35_ = context;
#line 167 "../editor/pathbar.vala"
				gtk_style_context_add_class (_tmp35_, "inexistent");
#line 1298 "pathbar.c"
			}
		}
#line 129 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 129 "../editor/pathbar.vala"
		_g_object_unref0 (item);
#line 1305 "pathbar.c"
	} else {
#line 170 "../editor/pathbar.vala"
		if (g_str_has_prefix (_data24_->non_ghost_path, _data24_->action_target)) {
#line 1309 "pathbar.c"
			GtkStyleContext* _tmp36_;
#line 171 "../editor/pathbar.vala"
			_tmp36_ = context;
#line 171 "../editor/pathbar.vala"
			gtk_style_context_remove_class (_tmp36_, "inexistent");
#line 1315 "pathbar.c"
		} else {
			GtkStyleContext* _tmp37_;
#line 173 "../editor/pathbar.vala"
			_tmp37_ = context;
#line 173 "../editor/pathbar.vala"
			gtk_style_context_add_class (_tmp37_, "inexistent");
#line 1322 "pathbar.c"
		}
	}
#line 127 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1327 "pathbar.c"
}


static void
___lambda23__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 127 "../editor/pathbar.vala"
	__lambda23_ (self, widget);
#line 1337 "pathbar.c"
}


void
path_bar_update_ghosts (PathBar* self,
                        const gchar* non_ghost_path,
                        gboolean is_search)
{
	Block24Data* _data24_;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 124 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 124 "../editor/pathbar.vala"
	g_return_if_fail (non_ghost_path != NULL);
#line 124 "../editor/pathbar.vala"
	_data24_ = g_slice_new0 (Block24Data);
#line 124 "../editor/pathbar.vala"
	_data24_->_ref_count_ = 1;
#line 124 "../editor/pathbar.vala"
	_data24_->self = g_object_ref (self);
#line 124 "../editor/pathbar.vala"
	_tmp0_ = g_strdup (non_ghost_path);
#line 124 "../editor/pathbar.vala"
	_g_free0 (_data24_->non_ghost_path);
#line 124 "../editor/pathbar.vala"
	_data24_->non_ghost_path = _tmp0_;
#line 124 "../editor/pathbar.vala"
	_data24_->is_search = is_search;
#line 126 "../editor/pathbar.vala"
	_tmp1_ = g_strdup ("");
#line 126 "../editor/pathbar.vala"
	_data24_->action_target = _tmp1_;
#line 127 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda23__gtk_callback, _data24_);
#line 124 "../editor/pathbar.vala"
	block24_data_unref (_data24_);
#line 124 "../editor/pathbar.vala"
	_data24_ = NULL;
#line 1377 "pathbar.c"
}


static Block25Data*
block25_data_ref (Block25Data* _data25_)
{
#line 177 "../editor/pathbar.vala"
	g_atomic_int_inc (&_data25_->_ref_count_);
#line 177 "../editor/pathbar.vala"
	return _data25_;
#line 1388 "pathbar.c"
}


static void
block25_data_unref (void * _userdata_)
{
	Block25Data* _data25_;
	_data25_ = (Block25Data*) _userdata_;
#line 177 "../editor/pathbar.vala"
	if (g_atomic_int_dec_and_test (&_data25_->_ref_count_)) {
#line 1399 "pathbar.c"
		PathBar* self;
#line 177 "../editor/pathbar.vala"
		self = _data25_->self;
#line 177 "../editor/pathbar.vala"
		_g_object_unref0 (self);
#line 177 "../editor/pathbar.vala"
		g_slice_free (Block25Data, _data25_);
#line 1407 "pathbar.c"
	}
}


static void
__lambda21_ (Block25Data* _data25_,
             GtkWidget* child)
{
	PathBar* self;
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
	PathBarItem* item = NULL;
	PathBarItem* _tmp3_;
#line 184 "../editor/pathbar.vala"
	self = _data25_->self;
#line 184 "../editor/pathbar.vala"
	g_return_if_fail (child != NULL);
#line 185 "../editor/pathbar.vala"
	if (!G_TYPE_CHECK_INSTANCE_TYPE (child, TYPE_PATH_BAR_ITEM)) {
#line 186 "../editor/pathbar.vala"
		return;
#line 1431 "pathbar.c"
	}
#line 187 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context (child);
#line 187 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 187 "../editor/pathbar.vala"
	context = _tmp1_;
#line 188 "../editor/pathbar.vala"
	_tmp2_ = context;
#line 188 "../editor/pathbar.vala"
	if (!gtk_style_context_has_class (_tmp2_, "active")) {
#line 189 "../editor/pathbar.vala"
		_g_object_unref0 (context);
#line 189 "../editor/pathbar.vala"
		return;
#line 1447 "pathbar.c"
	}
#line 190 "../editor/pathbar.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (child, TYPE_PATH_BAR_ITEM, PathBarItem));
#line 190 "../editor/pathbar.vala"
	item = _tmp3_;
#line 191 "../editor/pathbar.vala"
	if (_data25_->is_search) {
#line 1455 "pathbar.c"
		PathBarItem* _tmp4_;
		PathBarItem* _tmp5_;
		PathBarItem* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
#line 193 "../editor/pathbar.vala"
		_tmp4_ = item;
#line 193 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (_tmp4_, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 194 "../editor/pathbar.vala"
		_tmp5_ = item;
#line 194 "../editor/pathbar.vala"
		_tmp6_ = item;
#line 194 "../editor/pathbar.vala"
		_tmp7_ = path_bar_item_get_default_action (_tmp6_);
#line 194 "../editor/pathbar.vala"
		_tmp8_ = _tmp7_;
#line 194 "../editor/pathbar.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) _tmp5_, _tmp8_);
#line 1475 "pathbar.c"
	} else {
		PathBarItem* _tmp9_;
		PathBarItem* _tmp10_;
#line 198 "../editor/pathbar.vala"
		_tmp9_ = item;
#line 198 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (_tmp9_, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 199 "../editor/pathbar.vala"
		_tmp10_ = item;
#line 199 "../editor/pathbar.vala"
		gtk_actionable_set_action_name ((GtkActionable*) _tmp10_, "ui.empty");
#line 1487 "pathbar.c"
	}
#line 184 "../editor/pathbar.vala"
	_g_object_unref0 (item);
#line 184 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1493 "pathbar.c"
}


static void
___lambda21__gtk_callback (GtkWidget* widget,
                           gpointer self)
{
#line 184 "../editor/pathbar.vala"
	__lambda21_ (self, widget);
#line 1503 "pathbar.c"
}


static void
path_bar_update_cursors_for_search (PathBar* self,
                                    const gchar* current_path,
                                    gboolean is_search)
{
	Block25Data* _data25_;
#line 177 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 177 "../editor/pathbar.vala"
	g_return_if_fail (current_path != NULL);
#line 177 "../editor/pathbar.vala"
	_data25_ = g_slice_new0 (Block25Data);
#line 177 "../editor/pathbar.vala"
	_data25_->_ref_count_ = 1;
#line 177 "../editor/pathbar.vala"
	_data25_->self = g_object_ref (self);
#line 177 "../editor/pathbar.vala"
	_data25_->is_search = is_search;
#line 179 "../editor/pathbar.vala"
	if (_data25_->is_search) {
#line 1527 "pathbar.c"
		GtkStyleContext* _tmp0_;
#line 180 "../editor/pathbar.vala"
		_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 180 "../editor/pathbar.vala"
		gtk_style_context_add_class (_tmp0_, "greyed-pathbar");
#line 1533 "pathbar.c"
	} else {
		GtkStyleContext* _tmp1_;
#line 182 "../editor/pathbar.vala"
		_tmp1_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 182 "../editor/pathbar.vala"
		gtk_style_context_remove_class (_tmp1_, "greyed-pathbar");
#line 1540 "pathbar.c"
	}
#line 184 "../editor/pathbar.vala"
	gtk_container_foreach ((GtkContainer*) self, ___lambda21__gtk_callback, _data25_);
#line 177 "../editor/pathbar.vala"
	block25_data_unref (_data25_);
#line 177 "../editor/pathbar.vala"
	_data25_ = NULL;
#line 1548 "pathbar.c"
}


static void
path_bar_add_slash_label (PathBar* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
#line 208 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 210 "../editor/pathbar.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new ("/");
#line 210 "../editor/pathbar.vala"
	g_object_ref_sink (_tmp0_);
#line 210 "../editor/pathbar.vala"
	_tmp1_ = _tmp0_;
#line 210 "../editor/pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 210 "../editor/pathbar.vala"
	_g_object_unref0 (_tmp1_);
#line 1569 "pathbar.c"
}


static void
path_bar_add_path_bar_item (PathBar* self,
                            const gchar* label,
                            const gchar* complete_path,
                            gboolean is_folder,
                            gboolean block)
{
	PathBarItem* path_bar_item = NULL;
	PathBarItem* _tmp28_;
	PathBarItem* _tmp29_;
#line 213 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 213 "../editor/pathbar.vala"
	g_return_if_fail (label != NULL);
#line 213 "../editor/pathbar.vala"
	g_return_if_fail (complete_path != NULL);
#line 216 "../editor/pathbar.vala"
	if (is_folder) {
#line 1591 "pathbar.c"
		GVariant* variant = NULL;
		GVariant* _tmp0_;
		gchar* _variant = NULL;
		GVariant* _tmp1_;
		gchar* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		PathBarItem* _tmp13_;
#line 218 "../editor/pathbar.vala"
		_tmp0_ = g_variant_new_string (complete_path);
#line 218 "../editor/pathbar.vala"
		g_variant_ref_sink (_tmp0_);
#line 218 "../editor/pathbar.vala"
		variant = _tmp0_;
#line 219 "../editor/pathbar.vala"
		_tmp1_ = variant;
#line 219 "../editor/pathbar.vala"
		_tmp2_ = g_variant_print (_tmp1_, FALSE);
#line 219 "../editor/pathbar.vala"
		_variant = _tmp2_;
#line 220 "../editor/pathbar.vala"
		_tmp3_ = _variant;
#line 220 "../editor/pathbar.vala"
		_tmp4_ = g_strconcat ("ui.open-folder(", _tmp3_, NULL);
#line 220 "../editor/pathbar.vala"
		_tmp5_ = _tmp4_;
#line 220 "../editor/pathbar.vala"
		_tmp6_ = g_strconcat (_tmp5_, ")", NULL);
#line 220 "../editor/pathbar.vala"
		_tmp7_ = _tmp6_;
#line 220 "../editor/pathbar.vala"
		_tmp8_ = _variant;
#line 220 "../editor/pathbar.vala"
		_tmp9_ = g_strconcat ("ui.notify-folder-emptied(", _tmp8_, NULL);
#line 220 "../editor/pathbar.vala"
		_tmp10_ = _tmp9_;
#line 220 "../editor/pathbar.vala"
		_tmp11_ = g_strconcat (_tmp10_, ")", NULL);
#line 220 "../editor/pathbar.vala"
		_tmp12_ = _tmp11_;
#line 220 "../editor/pathbar.vala"
		_tmp13_ = path_bar_item_new (label, _tmp7_, _tmp12_);
#line 220 "../editor/pathbar.vala"
		g_object_ref_sink (_tmp13_);
#line 220 "../editor/pathbar.vala"
		_g_object_unref0 (path_bar_item);
#line 220 "../editor/pathbar.vala"
		path_bar_item = _tmp13_;
#line 220 "../editor/pathbar.vala"
		_g_free0 (_tmp12_);
#line 220 "../editor/pathbar.vala"
		_g_free0 (_tmp10_);
#line 220 "../editor/pathbar.vala"
		_g_free0 (_tmp7_);
#line 220 "../editor/pathbar.vala"
		_g_free0 (_tmp5_);
#line 216 "../editor/pathbar.vala"
		_g_free0 (_variant);
#line 216 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 1660 "pathbar.c"
	} else {
		GVariant* variant = NULL;
		GVariant* _tmp14_;
		gchar* _variant = NULL;
		GVariant* _tmp15_;
		gchar* _tmp16_;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		gchar* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		PathBarItem* _tmp27_;
#line 224 "../editor/pathbar.vala"
		_tmp14_ = g_variant_new ("(ss)", complete_path, "", NULL);
#line 224 "../editor/pathbar.vala"
		g_variant_ref_sink (_tmp14_);
#line 224 "../editor/pathbar.vala"
		variant = _tmp14_;
#line 225 "../editor/pathbar.vala"
		_tmp15_ = variant;
#line 225 "../editor/pathbar.vala"
		_tmp16_ = g_variant_print (_tmp15_, FALSE);
#line 225 "../editor/pathbar.vala"
		_variant = _tmp16_;
#line 226 "../editor/pathbar.vala"
		_tmp17_ = _variant;
#line 226 "../editor/pathbar.vala"
		_tmp18_ = g_strconcat ("ui.open-object(", _tmp17_, NULL);
#line 226 "../editor/pathbar.vala"
		_tmp19_ = _tmp18_;
#line 226 "../editor/pathbar.vala"
		_tmp20_ = g_strconcat (_tmp19_, ")", NULL);
#line 226 "../editor/pathbar.vala"
		_tmp21_ = _tmp20_;
#line 226 "../editor/pathbar.vala"
		_tmp22_ = _variant;
#line 226 "../editor/pathbar.vala"
		_tmp23_ = g_strconcat ("ui.notify-object-deleted(", _tmp22_, NULL);
#line 226 "../editor/pathbar.vala"
		_tmp24_ = _tmp23_;
#line 226 "../editor/pathbar.vala"
		_tmp25_ = g_strconcat (_tmp24_, ")", NULL);
#line 226 "../editor/pathbar.vala"
		_tmp26_ = _tmp25_;
#line 226 "../editor/pathbar.vala"
		_tmp27_ = path_bar_item_new (label, _tmp21_, _tmp26_);
#line 226 "../editor/pathbar.vala"
		g_object_ref_sink (_tmp27_);
#line 226 "../editor/pathbar.vala"
		_g_object_unref0 (path_bar_item);
#line 226 "../editor/pathbar.vala"
		path_bar_item = _tmp27_;
#line 226 "../editor/pathbar.vala"
		_g_free0 (_tmp26_);
#line 226 "../editor/pathbar.vala"
		_g_free0 (_tmp24_);
#line 226 "../editor/pathbar.vala"
		_g_free0 (_tmp21_);
#line 226 "../editor/pathbar.vala"
		_g_free0 (_tmp19_);
#line 216 "../editor/pathbar.vala"
		_g_free0 (_variant);
#line 216 "../editor/pathbar.vala"
		_g_variant_unref0 (variant);
#line 1730 "pathbar.c"
	}
#line 228 "../editor/pathbar.vala"
	_tmp28_ = path_bar_item;
#line 228 "../editor/pathbar.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp28_);
#line 229 "../editor/pathbar.vala"
	_tmp29_ = path_bar_item;
#line 229 "../editor/pathbar.vala"
	path_bar_activate_item (self, _tmp29_, block);
#line 213 "../editor/pathbar.vala"
	_g_object_unref0 (path_bar_item);
#line 1742 "pathbar.c"
}


static void
path_bar_activate_item (PathBar* self,
                        PathBarItem* item,
                        gboolean state)
{
	GtkStyleContext* context = NULL;
	GtkStyleContext* _tmp0_;
	GtkStyleContext* _tmp1_;
	GtkStyleContext* _tmp2_;
#line 232 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 232 "../editor/pathbar.vala"
	g_return_if_fail (item != NULL);
#line 234 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) item);
#line 234 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 234 "../editor/pathbar.vala"
	context = _tmp1_;
#line 235 "../editor/pathbar.vala"
	_tmp2_ = context;
#line 235 "../editor/pathbar.vala"
	if (state == gtk_style_context_has_class (_tmp2_, "active")) {
#line 236 "../editor/pathbar.vala"
		_g_object_unref0 (context);
#line 236 "../editor/pathbar.vala"
		return;
#line 1773 "pathbar.c"
	}
#line 237 "../editor/pathbar.vala"
	if (state) {
#line 1777 "pathbar.c"
		GtkStyleContext* _tmp3_;
#line 239 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT);
#line 240 "../editor/pathbar.vala"
		gtk_actionable_set_action_name ((GtkActionable*) item, "ui.empty");
#line 241 "../editor/pathbar.vala"
		_tmp3_ = context;
#line 241 "../editor/pathbar.vala"
		gtk_style_context_add_class (_tmp3_, "active");
#line 1787 "pathbar.c"
	} else {
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GtkStyleContext* _tmp6_;
#line 245 "../editor/pathbar.vala"
		path_bar_item_set_cursor_type (item, PATH_BAR_ITEM_CURSOR_TYPE_POINTER);
#line 246 "../editor/pathbar.vala"
		_tmp4_ = path_bar_item_get_default_action (item);
#line 246 "../editor/pathbar.vala"
		_tmp5_ = _tmp4_;
#line 246 "../editor/pathbar.vala"
		gtk_actionable_set_detailed_action_name ((GtkActionable*) item, _tmp5_);
#line 247 "../editor/pathbar.vala"
		_tmp6_ = context;
#line 247 "../editor/pathbar.vala"
		gtk_style_context_remove_class (_tmp6_, "active");
#line 1804 "pathbar.c"
	}
#line 232 "../editor/pathbar.vala"
	_g_object_unref0 (context);
#line 1808 "pathbar.c"
}


PathBar*
path_bar_construct (GType object_type)
{
	PathBar * self = NULL;
#line 21 "../editor/pathbar.vala"
	self = (PathBar*) g_object_new (object_type, NULL);
#line 21 "../editor/pathbar.vala"
	return self;
#line 1820 "pathbar.c"
}


PathBar*
path_bar_new (void)
{
#line 21 "../editor/pathbar.vala"
	return path_bar_construct (TYPE_PATH_BAR);
#line 1829 "pathbar.c"
}


const gchar*
path_bar_get_complete_path (PathBar* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 25 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_complete_path;
#line 25 "../editor/pathbar.vala"
	result = _tmp0_;
#line 25 "../editor/pathbar.vala"
	return result;
#line 1846 "pathbar.c"
}


static void
path_bar_set_complete_path (PathBar* self,
                            const gchar* value)
{
#line 25 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 25 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_get_complete_path (self)) != 0) {
#line 1858 "pathbar.c"
		gchar* _tmp0_;
#line 25 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 25 "../editor/pathbar.vala"
		_g_free0 (self->priv->_complete_path);
#line 25 "../editor/pathbar.vala"
		self->priv->_complete_path = _tmp0_;
#line 25 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY]);
#line 1868 "pathbar.c"
	}
}


static GObject *
path_bar_constructor (GType type,
                      guint n_construct_properties,
                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBar * self;
#line 27 "../editor/pathbar.vala"
	parent_class = G_OBJECT_CLASS (path_bar_parent_class);
#line 27 "../editor/pathbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
#line 29 "../editor/pathbar.vala"
	path_bar_add_slash_label (self);
#line 27 "../editor/pathbar.vala"
	return obj;
#line 1891 "pathbar.c"
}


static void
path_bar_class_init (PathBarClass * klass)
{
#line 21 "../editor/pathbar.vala"
	path_bar_parent_class = g_type_class_peek_parent (klass);
#line 21 "../editor/pathbar.vala"
	g_type_class_adjust_private_offset (klass, &PathBar_private_offset);
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_get_property;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_set_property;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->constructor = path_bar_constructor;
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = path_bar_finalize;
#line 21 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_COMPLETE_PATH_PROPERTY, path_bar_properties[PATH_BAR_COMPLETE_PATH_PROPERTY] = g_param_spec_string ("complete-path", "complete-path", "complete-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 21 "../editor/pathbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar.ui");
#line 21 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "root_button", FALSE, PathBar_private_offset + G_STRUCT_OFFSET (PathBarPrivate, root_button));
#line 1916 "pathbar.c"
}


static void
path_bar_instance_init (PathBar * self)
{
	gchar* _tmp0_;
#line 21 "../editor/pathbar.vala"
	self->priv = path_bar_get_instance_private (self);
#line 25 "../editor/pathbar.vala"
	_tmp0_ = g_strdup ("");
#line 25 "../editor/pathbar.vala"
	self->priv->_complete_path = _tmp0_;
#line 21 "../editor/pathbar.vala"
	g_type_ensure (TYPE_PATH_BAR_ITEM);
#line 21 "../editor/pathbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 1934 "pathbar.c"
}


static void
path_bar_finalize (GObject * obj)
{
	PathBar * self;
#line 21 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR, PathBar);
#line 23 "../editor/pathbar.vala"
	_g_object_unref0 (self->priv->root_button);
#line 25 "../editor/pathbar.vala"
	_g_free0 (self->priv->_complete_path);
#line 21 "../editor/pathbar.vala"
	G_OBJECT_CLASS (path_bar_parent_class)->finalize (obj);
#line 1950 "pathbar.c"
}


GType
path_bar_get_type (void)
{
	static volatile gsize path_bar_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBar), 0, (GInstanceInitFunc) path_bar_instance_init, NULL };
		GType path_bar_type_id;
		path_bar_type_id = g_type_register_static (gtk_box_get_type (), "PathBar", &g_define_type_info, 0);
		PathBar_private_offset = g_type_add_instance_private (path_bar_type_id, sizeof (PathBarPrivate));
		g_once_init_leave (&path_bar_type_id__volatile, path_bar_type_id);
	}
	return path_bar_type_id__volatile;
}


static void
_vala_path_bar_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
#line 21 "../editor/pathbar.vala"
	switch (property_id) {
#line 21 "../editor/pathbar.vala"
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
#line 21 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_get_complete_path (self));
#line 21 "../editor/pathbar.vala"
		break;
#line 1985 "pathbar.c"
		default:
#line 21 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/pathbar.vala"
		break;
#line 1991 "pathbar.c"
	}
}


static void
_vala_path_bar_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec)
{
	PathBar * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR, PathBar);
#line 21 "../editor/pathbar.vala"
	switch (property_id) {
#line 21 "../editor/pathbar.vala"
		case PATH_BAR_COMPLETE_PATH_PROPERTY:
#line 21 "../editor/pathbar.vala"
		path_bar_set_complete_path (self, g_value_get_string (value));
#line 21 "../editor/pathbar.vala"
		break;
#line 2012 "pathbar.c"
		default:
#line 21 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../editor/pathbar.vala"
		break;
#line 2018 "pathbar.c"
	}
}


static inline gpointer
path_bar_item_get_instance_private (PathBarItem* self)
{
	return G_STRUCT_MEMBER_P (self, PathBarItem_private_offset);
}


GType
path_bar_item_cursor_type_get_type (void)
{
	static volatile gsize path_bar_item_cursor_type_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_cursor_type_type_id__volatile)) {
		static const GEnumValue values[] = {{PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT, "PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT", "default"}, {PATH_BAR_ITEM_CURSOR_TYPE_POINTER, "PATH_BAR_ITEM_CURSOR_TYPE_POINTER", "pointer"}, {PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT, "PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT", "context"}, {0, NULL, NULL}};
		GType path_bar_item_cursor_type_type_id;
		path_bar_item_cursor_type_type_id = g_enum_register_static ("PathBarItemCursorType", values);
		g_once_init_leave (&path_bar_item_cursor_type_type_id__volatile, path_bar_item_cursor_type_type_id);
	}
	return path_bar_item_cursor_type_type_id__volatile;
}


void
path_bar_item_set_cursor_type (PathBarItem* self,
                               PathBarItemCursorType cursor_type)
{
	gboolean _tmp0_;
#line 275 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 277 "../editor/pathbar.vala"
	self->priv->cursor_type = cursor_type;
#line 278 "../editor/pathbar.vala"
	_tmp0_ = self->priv->hover;
#line 278 "../editor/pathbar.vala"
	if (_tmp0_) {
#line 279 "../editor/pathbar.vala"
		path_bar_item_set_new_cursor_type (self, cursor_type);
#line 2059 "pathbar.c"
	}
}


static void
path_bar_item_set_new_cursor_type (PathBarItem* self,
                                   PathBarItemCursorType new_cursor_type)
{
	GdkWindow* gdk_window = NULL;
	GdkWindow* _tmp0_;
	GdkWindow* _tmp1_;
	GdkDisplay* display = NULL;
	GdkDisplay* _tmp2_;
	GdkDisplay* _tmp3_;
	gboolean _tmp4_ = FALSE;
	GdkWindow* _tmp5_;
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp11_;
	GdkCursor* _tmp12_;
#line 282 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 284 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_window ((GtkWidget*) self);
#line 284 "../editor/pathbar.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 284 "../editor/pathbar.vala"
	gdk_window = _tmp1_;
#line 285 "../editor/pathbar.vala"
	_tmp2_ = gdk_display_get_default ();
#line 285 "../editor/pathbar.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 285 "../editor/pathbar.vala"
	display = _tmp3_;
#line 286 "../editor/pathbar.vala"
	_tmp5_ = gdk_window;
#line 286 "../editor/pathbar.vala"
	if (_tmp5_ == NULL) {
#line 286 "../editor/pathbar.vala"
		_tmp4_ = TRUE;
#line 2099 "pathbar.c"
	} else {
		GdkDisplay* _tmp6_;
#line 286 "../editor/pathbar.vala"
		_tmp6_ = display;
#line 286 "../editor/pathbar.vala"
		_tmp4_ = _tmp6_ == NULL;
#line 2106 "pathbar.c"
	}
#line 286 "../editor/pathbar.vala"
	if (_tmp4_) {
#line 287 "../editor/pathbar.vala"
		_g_object_unref0 (display);
#line 287 "../editor/pathbar.vala"
		_g_object_unref0 (gdk_window);
#line 287 "../editor/pathbar.vala"
		return;
#line 2116 "pathbar.c"
	}
#line 289 "../editor/pathbar.vala"
	cursor = NULL;
#line 290 "../editor/pathbar.vala"
	switch (new_cursor_type) {
#line 290 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT:
#line 2124 "pathbar.c"
		{
#line 292 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 292 "../editor/pathbar.vala"
			cursor = NULL;
#line 292 "../editor/pathbar.vala"
			break;
#line 2132 "pathbar.c"
		}
#line 290 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_POINTER:
#line 2136 "pathbar.c"
		{
			GdkDisplay* _tmp7_;
			GdkCursor* _tmp8_;
#line 293 "../editor/pathbar.vala"
			_tmp7_ = display;
#line 293 "../editor/pathbar.vala"
			_tmp8_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gdk_display_get_type (), GdkDisplay), "pointer");
#line 293 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 293 "../editor/pathbar.vala"
			cursor = _tmp8_;
#line 293 "../editor/pathbar.vala"
			break;
#line 2150 "pathbar.c"
		}
#line 290 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT:
#line 2154 "pathbar.c"
		{
			GdkDisplay* _tmp9_;
			GdkCursor* _tmp10_;
#line 294 "../editor/pathbar.vala"
			_tmp9_ = display;
#line 294 "../editor/pathbar.vala"
			_tmp10_ = gdk_cursor_new_from_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gdk_display_get_type (), GdkDisplay), "context-menu");
#line 294 "../editor/pathbar.vala"
			_g_object_unref0 (cursor);
#line 294 "../editor/pathbar.vala"
			cursor = _tmp10_;
#line 294 "../editor/pathbar.vala"
			break;
#line 2168 "pathbar.c"
		}
		default:
#line 290 "../editor/pathbar.vala"
		break;
#line 2173 "pathbar.c"
	}
#line 296 "../editor/pathbar.vala"
	_tmp11_ = gdk_window;
#line 296 "../editor/pathbar.vala"
	_tmp12_ = cursor;
#line 296 "../editor/pathbar.vala"
	gdk_window_set_cursor (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gdk_window_get_type (), GdkWindow), _tmp12_);
#line 282 "../editor/pathbar.vala"
	_g_object_unref0 (cursor);
#line 282 "../editor/pathbar.vala"
	_g_object_unref0 (display);
#line 282 "../editor/pathbar.vala"
	_g_object_unref0 (gdk_window);
#line 2187 "pathbar.c"
}


static void
path_bar_item_update_cursor (PathBarItem* self)
{
	GtkStyleContext* _tmp0_;
	PathBarItemCursorType _tmp1_;
	GMenu* menu = NULL;
	GMenu* _tmp3_;
	GMenu* _tmp4_;
	GMenu* _tmp5_;
	GtkPopover* popover_test = NULL;
	GMenu* _tmp6_;
	GtkPopover* _tmp7_;
	GtkPopover* _tmp8_;
#line 300 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 302 "../editor/pathbar.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 302 "../editor/pathbar.vala"
	if (gtk_style_context_has_class (_tmp0_, "inexistent")) {
#line 303 "../editor/pathbar.vala"
		return;
#line 2212 "pathbar.c"
	}
#line 305 "../editor/pathbar.vala"
	_tmp1_ = self->priv->cursor_type;
#line 305 "../editor/pathbar.vala"
	if (_tmp1_ != PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT) {
#line 2218 "pathbar.c"
		PathBarItemCursorType _tmp2_;
#line 307 "../editor/pathbar.vala"
		self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_CONTEXT;
#line 308 "../editor/pathbar.vala"
		_tmp2_ = self->priv->cursor_type;
#line 308 "../editor/pathbar.vala"
		path_bar_item_set_new_cursor_type (self, _tmp2_);
#line 309 "../editor/pathbar.vala"
		return;
#line 2228 "pathbar.c"
	}
#line 312 "../editor/pathbar.vala"
	_tmp3_ = g_menu_new ();
#line 312 "../editor/pathbar.vala"
	menu = _tmp3_;
#line 313 "../editor/pathbar.vala"
	_tmp4_ = menu;
#line 313 "../editor/pathbar.vala"
	g_menu_append (_tmp4_, _ ("Copy current path"), "ui.copy-path");
#line 314 "../editor/pathbar.vala"
	_tmp5_ = menu;
#line 314 "../editor/pathbar.vala"
	g_menu_freeze (_tmp5_);
#line 316 "../editor/pathbar.vala"
	_tmp6_ = menu;
#line 316 "../editor/pathbar.vala"
	_tmp7_ = (GtkPopover*) gtk_popover_new_from_model ((GtkWidget*) self, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_menu_model_get_type (), GMenuModel));
#line 316 "../editor/pathbar.vala"
	g_object_ref_sink (_tmp7_);
#line 316 "../editor/pathbar.vala"
	popover_test = _tmp7_;
#line 317 "../editor/pathbar.vala"
	_tmp8_ = popover_test;
#line 317 "../editor/pathbar.vala"
	gtk_popover_popup (_tmp8_);
#line 300 "../editor/pathbar.vala"
	_g_object_unref0 (popover_test);
#line 300 "../editor/pathbar.vala"
	_g_object_unref0 (menu);
#line 2258 "pathbar.c"
}


static void
_path_bar_item_update_cursor_gtk_button_clicked (GtkButton* _sender,
                                                 gpointer self)
{
#line 253 "../editor/pathbar.vala"
	path_bar_item_update_cursor ((PathBarItem*) self);
#line 2268 "pathbar.c"
}


PathBarItem*
path_bar_item_construct (GType object_type,
                         const gchar* label,
                         const gchar* _default_action,
                         const gchar* _alternative_action)
{
	PathBarItem * self = NULL;
	GtkLabel* _tmp0_;
#line 320 "../editor/pathbar.vala"
	g_return_val_if_fail (label != NULL, NULL);
#line 320 "../editor/pathbar.vala"
	g_return_val_if_fail (_default_action != NULL, NULL);
#line 320 "../editor/pathbar.vala"
	g_return_val_if_fail (_alternative_action != NULL, NULL);
#line 322 "../editor/pathbar.vala"
	self = (PathBarItem*) g_object_new (object_type, "text-string", label, "default-action", _default_action, "alternative-action", _alternative_action, NULL);
#line 323 "../editor/pathbar.vala"
	_tmp0_ = self->priv->text_label;
#line 323 "../editor/pathbar.vala"
	gtk_label_set_text (_tmp0_, label);
#line 324 "../editor/pathbar.vala"
	gtk_actionable_set_detailed_action_name ((GtkActionable*) self, _default_action);
#line 320 "../editor/pathbar.vala"
	return self;
#line 2296 "pathbar.c"
}


PathBarItem*
path_bar_item_new (const gchar* label,
                   const gchar* _default_action,
                   const gchar* _alternative_action)
{
#line 320 "../editor/pathbar.vala"
	return path_bar_item_construct (TYPE_PATH_BAR_ITEM, label, _default_action, _alternative_action);
#line 2307 "pathbar.c"
}


const gchar*
path_bar_item_get_alternative_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 255 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_alternative_action;
#line 255 "../editor/pathbar.vala"
	result = _tmp0_;
#line 255 "../editor/pathbar.vala"
	return result;
#line 2324 "pathbar.c"
}


static void
path_bar_item_set_alternative_action (PathBarItem* self,
                                      const gchar* value)
{
#line 255 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 255 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_alternative_action (self)) != 0) {
#line 2336 "pathbar.c"
		gchar* _tmp0_;
#line 255 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 255 "../editor/pathbar.vala"
		_g_free0 (self->priv->_alternative_action);
#line 255 "../editor/pathbar.vala"
		self->priv->_alternative_action = _tmp0_;
#line 255 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY]);
#line 2346 "pathbar.c"
	}
}


const gchar*
path_bar_item_get_default_action (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 256 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 256 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_default_action;
#line 256 "../editor/pathbar.vala"
	result = _tmp0_;
#line 256 "../editor/pathbar.vala"
	return result;
#line 2364 "pathbar.c"
}


static void
path_bar_item_set_default_action (PathBarItem* self,
                                  const gchar* value)
{
#line 256 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 256 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_default_action (self)) != 0) {
#line 2376 "pathbar.c"
		gchar* _tmp0_;
#line 256 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 256 "../editor/pathbar.vala"
		_g_free0 (self->priv->_default_action);
#line 256 "../editor/pathbar.vala"
		self->priv->_default_action = _tmp0_;
#line 256 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY]);
#line 2386 "pathbar.c"
	}
}


const gchar*
path_bar_item_get_text_string (PathBarItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 257 "../editor/pathbar.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 257 "../editor/pathbar.vala"
	_tmp0_ = self->priv->_text_string;
#line 257 "../editor/pathbar.vala"
	result = _tmp0_;
#line 257 "../editor/pathbar.vala"
	return result;
#line 2404 "pathbar.c"
}


static void
path_bar_item_set_text_string (PathBarItem* self,
                               const gchar* value)
{
#line 257 "../editor/pathbar.vala"
	g_return_if_fail (self != NULL);
#line 257 "../editor/pathbar.vala"
	if (g_strcmp0 (value, path_bar_item_get_text_string (self)) != 0) {
#line 2416 "pathbar.c"
		gchar* _tmp0_;
#line 257 "../editor/pathbar.vala"
		_tmp0_ = g_strdup (value);
#line 257 "../editor/pathbar.vala"
		_g_free0 (self->priv->_text_string);
#line 257 "../editor/pathbar.vala"
		self->priv->_text_string = _tmp0_;
#line 257 "../editor/pathbar.vala"
		g_object_notify_by_pspec ((GObject *) self, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY]);
#line 2426 "pathbar.c"
	}
}


static gboolean
_path_bar_item___lambda19_ (PathBarItem* self)
{
	gboolean result = FALSE;
	PathBarItemCursorType _tmp0_;
#line 271 "../editor/pathbar.vala"
	self->priv->hover = TRUE;
#line 271 "../editor/pathbar.vala"
	_tmp0_ = self->priv->cursor_type;
#line 271 "../editor/pathbar.vala"
	path_bar_item_set_new_cursor_type (self, _tmp0_);
#line 2442 "pathbar.c"
}


static gboolean
__path_bar_item___lambda19__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda19_ ((PathBarItem*) self);
#line 271 "../editor/pathbar.vala"
	return result;
#line 2455 "pathbar.c"
}


static gboolean
_path_bar_item___lambda20_ (PathBarItem* self)
{
	gboolean result = FALSE;
#line 272 "../editor/pathbar.vala"
	self->priv->hover = FALSE;
#line 272 "../editor/pathbar.vala"
	path_bar_item_set_new_cursor_type (self, PATH_BAR_ITEM_CURSOR_TYPE_DEFAULT);
#line 2467 "pathbar.c"
}


static gboolean
__path_bar_item___lambda20__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                           GdkEventCrossing* event,
                                                           gpointer self)
{
	gboolean result;
	result = _path_bar_item___lambda20_ ((PathBarItem*) self);
#line 272 "../editor/pathbar.vala"
	return result;
#line 2480 "pathbar.c"
}


static GObject *
path_bar_item_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PathBarItem * self;
#line 269 "../editor/pathbar.vala"
	parent_class = G_OBJECT_CLASS (path_bar_item_parent_class);
#line 269 "../editor/pathbar.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 269 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 271 "../editor/pathbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __path_bar_item___lambda19__gtk_widget_enter_notify_event, self, 0);
#line 272 "../editor/pathbar.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __path_bar_item___lambda20__gtk_widget_leave_notify_event, self, 0);
#line 269 "../editor/pathbar.vala"
	return obj;
#line 2504 "pathbar.c"
}


static void
path_bar_item_class_init (PathBarItemClass * klass)
{
#line 253 "../editor/pathbar.vala"
	path_bar_item_parent_class = g_type_class_peek_parent (klass);
#line 253 "../editor/pathbar.vala"
	g_type_class_adjust_private_offset (klass, &PathBarItem_private_offset);
#line 253 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_path_bar_item_get_property;
#line 253 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_path_bar_item_set_property;
#line 253 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->constructor = path_bar_item_constructor;
#line 253 "../editor/pathbar.vala"
	G_OBJECT_CLASS (klass)->finalize = path_bar_item_finalize;
#line 253 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY] = g_param_spec_string ("alternative-action", "alternative-action", "alternative-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 253 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY] = g_param_spec_string ("default-action", "default-action", "default-action", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 253 "../editor/pathbar.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), PATH_BAR_ITEM_TEXT_STRING_PROPERTY, path_bar_item_properties[PATH_BAR_ITEM_TEXT_STRING_PROPERTY] = g_param_spec_string ("text-string", "text-string", "text-string", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 253 "../editor/pathbar.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/ca/desrt/dconf-editor/ui/pathbar-item.ui");
#line 253 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "text_label", FALSE, PathBarItem_private_offset + G_STRUCT_OFFSET (PathBarItemPrivate, text_label));
#line 253 "../editor/pathbar.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "update_cursor", G_CALLBACK(_path_bar_item_update_cursor_gtk_button_clicked));
#line 2535 "pathbar.c"
}


static void
path_bar_item_instance_init (PathBarItem * self)
{
#line 253 "../editor/pathbar.vala"
	self->priv = path_bar_item_get_instance_private (self);
#line 265 "../editor/pathbar.vala"
	self->priv->cursor_type = PATH_BAR_ITEM_CURSOR_TYPE_POINTER;
#line 267 "../editor/pathbar.vala"
	self->priv->hover = FALSE;
#line 253 "../editor/pathbar.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 2550 "pathbar.c"
}


static void
path_bar_item_finalize (GObject * obj)
{
	PathBarItem * self;
#line 253 "../editor/pathbar.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 255 "../editor/pathbar.vala"
	_g_free0 (self->priv->_alternative_action);
#line 256 "../editor/pathbar.vala"
	_g_free0 (self->priv->_default_action);
#line 257 "../editor/pathbar.vala"
	_g_free0 (self->priv->_text_string);
#line 258 "../editor/pathbar.vala"
	_g_object_unref0 (self->priv->text_label);
#line 253 "../editor/pathbar.vala"
	G_OBJECT_CLASS (path_bar_item_parent_class)->finalize (obj);
#line 2570 "pathbar.c"
}


GType
path_bar_item_get_type (void)
{
	static volatile gsize path_bar_item_type_id__volatile = 0;
	if (g_once_init_enter (&path_bar_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PathBarItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) path_bar_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PathBarItem), 0, (GInstanceInitFunc) path_bar_item_instance_init, NULL };
		GType path_bar_item_type_id;
		path_bar_item_type_id = g_type_register_static (gtk_button_get_type (), "PathBarItem", &g_define_type_info, 0);
		PathBarItem_private_offset = g_type_add_instance_private (path_bar_item_type_id, sizeof (PathBarItemPrivate));
		g_once_init_leave (&path_bar_item_type_id__volatile, path_bar_item_type_id);
	}
	return path_bar_item_type_id__volatile;
}


static void
_vala_path_bar_item_get_property (GObject * object,
                                  guint property_id,
                                  GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 253 "../editor/pathbar.vala"
	switch (property_id) {
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
#line 253 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_alternative_action (self));
#line 253 "../editor/pathbar.vala"
		break;
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
#line 253 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_default_action (self));
#line 253 "../editor/pathbar.vala"
		break;
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
#line 253 "../editor/pathbar.vala"
		g_value_set_string (value, path_bar_item_get_text_string (self));
#line 253 "../editor/pathbar.vala"
		break;
#line 2617 "pathbar.c"
		default:
#line 253 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 253 "../editor/pathbar.vala"
		break;
#line 2623 "pathbar.c"
	}
}


static void
_vala_path_bar_item_set_property (GObject * object,
                                  guint property_id,
                                  const GValue * value,
                                  GParamSpec * pspec)
{
	PathBarItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PATH_BAR_ITEM, PathBarItem);
#line 253 "../editor/pathbar.vala"
	switch (property_id) {
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_ALTERNATIVE_ACTION_PROPERTY:
#line 253 "../editor/pathbar.vala"
		path_bar_item_set_alternative_action (self, g_value_get_string (value));
#line 253 "../editor/pathbar.vala"
		break;
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_DEFAULT_ACTION_PROPERTY:
#line 253 "../editor/pathbar.vala"
		path_bar_item_set_default_action (self, g_value_get_string (value));
#line 253 "../editor/pathbar.vala"
		break;
#line 253 "../editor/pathbar.vala"
		case PATH_BAR_ITEM_TEXT_STRING_PROPERTY:
#line 253 "../editor/pathbar.vala"
		path_bar_item_set_text_string (self, g_value_get_string (value));
#line 253 "../editor/pathbar.vala"
		break;
#line 2656 "pathbar.c"
		default:
#line 253 "../editor/pathbar.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 253 "../editor/pathbar.vala"
		break;
#line 2662 "pathbar.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



